`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    15:06:59 03/17/2016 
// Design Name: 
// Module Name:    bcdcnt_up 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module bcdcnt_up(
    a,
	 q,     // output
    clk,   // global clock
    rst_n  // active low reset
    );

	output [3:0]q; // right output
	output [3:0]a; // left output
	input clk;      // global clock
	input rst_n;    // active low reset

	reg [3:0]q;       // output (in always block)
	reg [3:0]q_tmp;   // input to dff (in always block)
	reg [3:0]a;       // output (in always block)
	reg [3:0]a_tmp;   // input to dff (in always block) 

	// Combinational logics
	always @*
	  if (q==4'd9 && a!=4'd9)
			begin
				q_tmp=4'd0;
				a_tmp=a+4'd1;
			end
		else if(q==4'd9 && a==4'd9)
			begin
				q_tmp=4'd0;
				a_tmp=4'd0;
			end
	  else 
		  begin
				q_tmp=q+4'd1;
				a_tmp=a+4'd0;
			end
		
	// Sequential logics: Flip flops
	always @(posedge clk or negedge rst_n)
	  if (~rst_n)
			begin  
				  q<=4'd0;
				  a<=4'd0; 
			end
	  else
			begin
				q<=q_tmp;
				a<=a_tmp;
			end


endmodule
